"""<one line to give the program's name and a brief idea of what it does.>
    Copyright (C) 2013 <name of author> Catrilas, aj_2745, ABT Benjaminsn
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>."""


import pygame
from math import sqrt,degrees

class Chsprite(pygame.sprite.Sprite):                     #class to handle sprites
    def __init__(self,x,y,image,movefunc,hp,moveturn,attack,attackfunc,damage,attacktimer,pig=False):                       
        pygame.sprite.Sprite.__init__(self)             #Call the parent's constructor
        if pig:
            self.image=pygame.image.load(image[0]).convert_alpha()
            self.original=self.image.copy()
            self.original2=pygame.image.load(image[1]).convert_alpha()
        else:
            image=pygame.image.load(image).convert_alpha()
            self.image=image
            self.original = self.image.copy()
        self.mask=pygame.mask.from_surface(self.image)  #finds the bitmasks so that it doesnt do this every time we check for collision
        self.rect=self.image.get_rect()                 #find the rect of the image
        self.rect.left,self.rect.top=x,y                #place it at the appropriate spot
        self.movefunc=movefunc                          #function for running movement ai for this sprite
        self.attack=attack                              #function that controls how attacks work
        self.attackfunc=attackfunc
        self.hp=hp                                      #hit points, 
        self.damage=damage                              #how much dmg it causes if you run into it
        self.moveturn=moveturn
        self.counter=1
        self.pig=pig
        self.pigmoveturn=moveturn
        self.oldleft,self.oldtop=self.rect.left,self.rect.top
        self.direction=1
        self.olddirection=1
        self.direc=0
        if self.pig==True:
            self.invin=1
            
        self.randlong=0
        self.attacktimer=attacktimer
    def update(self,wall_list=None):                   #used to update movement and attack
        if self.pig==True:              #finds if you need to compensate for going diagnally on how fast your going
            self.invin-=1
            keys=pygame.key.get_pressed()
            if (   (keys[pygame.K_w] and keys[pygame.K_a] and not (keys[pygame.K_s] or keys[pygame.K_d]))
                or (keys[pygame.K_s] and keys[pygame.K_a] and not (keys[pygame.K_w] or keys[pygame.K_d]))
                or (keys[pygame.K_w] and keys[pygame.K_d] and not (keys[pygame.K_s] or keys[pygame.K_a]))
                or (keys[pygame.K_s] and keys[pygame.K_d] and not (keys[pygame.K_w] or keys[pygame.K_a]))):
                self.moveturn=int(self.pigmoveturn*sqrt(2))
            else:
                self.moveturn=self.pigmoveturn
        if (self.counter % self.moveturn)== 0 and self.movefunc!=None:
            if self.randlong<1:
                self.direc,self.randlong,self.rect.center=self.movefunc(self.rect.center,self.randlong,self.direc,wall_list,self)
            else:
                self.direc,self.randlong,self.rect.center=self.movefunc(self.rect.center,self.randlong,self.direc,wall_list,self)
            self.randlong-=1
            if self.direc>4:
                self.moveturn=int(self.pigmoveturn*sqrt(2))
            else:
                self.moveturn=self.pigmoveturn
            if self.pig:
                if self.oldleft<self.rect.left:             #tests for direction sprite moved and changes the image rotation accordingly
                    if self.oldtop<self.rect.top and self.direction!=4:
                        self.image=self.original2.copy()
                        self.image=pygame.transform.rotate(self.image,180)
                        self.mask=pygame.mask.from_surface(self.image)
                        self.direction=4
                    elif self.oldtop>self.rect.top and self.direction!=2:
                        self.image=self.original2.copy()
                        self.image=pygame.transform.rotate(self.image,270)
                        self.mask=pygame.mask.from_surface(self.image)
                        self.direction=2
                    elif self.oldtop==self.rect.top and self.direction!=3:
                        self.image=self.original.copy()
                        self.direction=3
                        self.image=pygame.transform.rotate(self.image,270)
                        self.mask=pygame.mask.from_surface(self.image)
                elif self.oldleft>self.rect.left:
                    if self.oldtop<self.rect.top and self.direction!=6:
                        self.image=self.original2.copy()
                        self.direction=6
                        self.image=pygame.transform.rotate(self.image,90)
                        self.mask=pygame.mask.from_surface(self.image)
                    elif self.oldtop>self.rect.top and self.direction!=8:
                        self.image=self.original2.copy()
                        self.direction=8
                        self.mask=pygame.mask.from_surface(self.image)
                    elif self.oldtop==self.rect.top and self.direction!=7:
                        self.image=self.original.copy()
                        self.direction=7
                        self.image=pygame.transform.rotate(self.image,90)
                        self.mask=pygame.mask.from_surface(self.image)
                elif self.oldtop>self.rect.top and self.direction!=1:
                    self.image=self.original.copy()
                    self.direction=1
                    self.mask=pygame.mask.from_surface(self.image)
                elif self.oldtop<self.rect.top and self.direction!=5:
                    self.image=self.original.copy()
                    self.direction=5
                    self.image=pygame.transform.rotate(self.image,180)
                    self.mask=pygame.mask.from_surface(self.image)
                self.olddirection=self.direction
                self.oldleft,self.oldtop=self.rect.left,self.rect.top
        if self.attack!=None and (self.counter % self.attacktimer) == 0:
            self.attack(self.attackfunc,self)
        self.counter+=1

class Bullet(pygame.sprite.Sprite):
    def __init__(self,x,y,image,damage,direction,moveturn,movefunc,target=None):
        pygame.sprite.Sprite.__init__(self)             #Call the parent's constructor
        self.image=image
        direc=degrees(direction)
        self.image=pygame.transform.rotate(self.image,direc)
        self.mask=pygame.mask.from_surface(self.image)  #finds the bitmasks so that it doesnt do this every time we check for collision
        self.rect=self.image.get_rect()                 #find the rect of the image
        self.rect.center=(x,y)                          #place it at the appropriate spot
        self.movefunc=movefunc                          #function for running movement ai for this sprite
        self.damage=damage                              #damage done
        self.counter=1                                  #keeps track of how many updates have been called
        self.moveturn=moveturn                          #determins how fast it moves
        self.direction=direction                        #says what direction the round is going in radians
        self.target=target                              #not currently used, well use if i make things track the pig
        self.realrect=(float(x),float(y))               #keeps track of the true position of the bullet but the shown one is what matters, this is for precicion
    def update(self,pig=None):                               #updates movements
        if (self.counter % self.moveturn)==0:
            self.realrect=self.movefunc(self.direction,self.realrect,self.target)
            self.rect.left=int(self.realrect[0])
            self.rect.top =int(self.realrect[1])
        self.counter+=1

class Wall(pygame.sprite.Sprite):  #Handle walls brought in from the dictionary
    def __init__(self,x,y,width=32,height=32): # Constructor function Slowed a map load down to much to be in the zip
        pygame.sprite.Sprite.__init__(self)    #Call the parent's constructor
        self.image = pygame.image.load("wall.png").convert_alpha()
        self.rect = self.image.get_rect()      # Make our top-left corner the passed-in location.
        self.rect.top,self.rect.left = y,x
        self.mask=pygame.mask.from_surface(self.image)  #finds the bitmasks so that it doesnt do this every time we check for collision


